// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.model.DeploymentEnvironment");
dojo.require("com.ibm.bpm.QuickStart.Helpers.WCCMHelper");
dojo.require("com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.ProcessCenterConsole");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.PerformanceAdminConsole");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.ProcessAdminConsole");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.ProcessPortal");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.WASAdminConsole");
//dojo.require("com.ibm.bpm.QuickStart.Step.StopDeploymentEnvironment");
//dojo.require("com.ibm.bpm.QuickStart.Step.StartDeploymentEnvironment");


dojo.declare("com.ibm.bpm.QuickStart.model.DeploymentEnvironment",[], {
    deName:null,
    deType:null,
    deEnvironmentType:null,
    dmgr:null,
    processCenter: new Array(),
    performanceAdmin: new Array(),
    processAdmin: new Array(),
    processPortal: new Array(),
    firstOnlineProcessCenter:null,
    firstOnlineProcessAdmin:null,
    firstOnlineProcessPortal:null,
    firstOnlinePerformanceAdmin:null,
    cellUserName:null,
    cellPassword:null,
    clazz:"DeploymentEnvironment",
    logger:null,
    //137696
    mode:1,
    
    constructor: function(deName,dmgr,userName,password,mode){
        this.logger=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getStaticLogger();
        this.setDmgr(dmgr);
        this.setDeName(deName);
        this.setCellUserName(userName);
        this.setCellPassword(password);
        this.setDeEnvironmentType(this.determineDeEnvironmentType());
        this.setDeType(this.determineDeType());
    },
    //137696
    setMode: function(mode)
    {
        this.mode=mode;
    },
    getCellUserName: function(){
        return this.cellUserName;
    },
    setCellUserName: function(userName){
    	// 137696 
        //if(this.cellUserName==null){
        if((this.mode == 0 && this.cellUserName==null) || this.mode ==1){
            this.cellUserName=userName;
            this.logger.logMessage("User entered or corrected the DE user name.");
        }
    },
    setCellPassword: function(password){
    	//137696 
        //if(this.cellPassword==null){
        if((this.mode == 0 && this.cellPassword==null) || this.mode ==1){
            this.cellPassword=password;
            this.logger.logMessage("User entered or corrected the DE password.");
        }
    },
    getCellPassword: function(){
        return this.cellPassword;
    },
    getDeName: function(){
        return this.deName;
    },
    setDeName: function(deName){
        if(this.deName==null){
            this.deName = deName;
        }
    },
    getDeType: function(){
        return this.deType;    
    },
    setDeType: function(deType){
        if(this.deType==null){
            this.deType=deType;
        }
    },
    getDeEnvironmentType: function(){
        return this.deEnvironmentType;
    },
    setDeEnvironmentType: function(deEnvironmentType){
        if(this.deEnvironmentType==null){
            this.deEnvironmentType = deEnvironmentType;
        }
    },
    getDmgr: function(){
        return this.dmgr;
    },
    setDmgr: function(dmgr){
        if(this.dmgr==null){
            this.dmgr = dmgr; 
        }
    },
    getProcessCenter: function(){
	    return this.processCenter;
    },
    getProcessAdmin: function(){
    	return this.processAdmin;
    },
    getProcessPortal: function(){
	    return this.processPortal;
    },
    getPerformanceAdmin: function(){
	    return this.performanceAdmin;
    },
    
    getFirstOnlineProcessCenter: function(){
       var method = "getFirstOnlineProcessCenter";
       this.logger.entering(this.clazz,method,"getFirstOnlineProcessCenter"); 

    	if(this.getProcessCenter()==null){
    		return null;
    	}
        if(this.firstOnlineProcessCenter==null){
            for(var i=0;i<this.getProcessCenter().length;i++){
                if(this.getProcessCenter()[i].isOnline()){
                    this.firstOnlineProcessCenter = this.getProcessCenter()[i];
                    break;
                }
            }
        }

       this.logger.exiting(this.clazz,method,"End of getFirstOnlineProcessCenter"+this.firstOnlineProcessCenter);
        return this.firstOnlineProcessCenter;
    },
    getFirstOnlineProcessAdmin: function(){
       var method = "getFirstOnlineProcessAdmin";
       this.logger.entering(this.clazz,method,"getFirstOnlineProcessAdmin"); 


        if(this.getProcessAdmin()==null){
        	return null;
        }
        if(this.firstOnlineProcessAdmin==null){
             for(var i=0;i<this.getProcessAdmin().length;i++){
                if(this.getProcessAdmin()[i].isOnline()){
                    this.firstOnlineProcessAdmin = this.getProcessAdmin()[i];
                    break;
                }
             }
        }

       this.logger.exiting(this.clazz,method,"End of getFirstOnlineProcessAdmin"+this.firstOnlineProcessAdmin);
        return this.firstOnlineProcessAdmin;
    
    },
    getFirstOnlineProcessPortal: function(){
       var method = "getFirstOnlineProcessPortal";
       this.logger.entering(this.clazz,method,"getFirstOnlineProcessPortal"); 

    	if(this.getProcessPortal()==null){
    		return null;
    	}
        if(this.firstOnlineProcessPortal==null){  
            for(var i=0;i<this.getProcessPortal().length;i++){
                if(this.getProcessPortal()[i].isOnline()){
                    this.firstOnlineProcessPortal = this.getProcessPortal()[i];
                    break;
                }
             }
        }

       this.logger.exiting(this.clazz,method,"End of getFirstOnlineProcessPortal"+this.firstOnlineProcessPortal);
        return this.firstOnlineProcessPortal;
    },
    getFirstOnlinePerformanceAdmin: function(){
       var method = "getFirstOnlinePerformanceAdmin";
       this.logger.entering(this.clazz,method,"getFirstOnlinePerformanceAdmin"); 


    	if(this.getPerformanceAdmin()==null){
    		return null;
    	}
        if(this.firstOnlinePerformanceAdmin==null){
             for(var i=0;i<this.getPerformanceAdmin().length;i++){
                if(this.getPerformanceAdmin()[i].isOnline()){
                    this.firstOnlinePerformanceAdmin = this.getPerformanceAdmin()[i];
                    break;
                }
             }
        }

       this.logger.exiting(this.clazz,method,"End of getFirstOnlinePerformanceAdmin"+this.firstOnlinePerformanceAdmin);
        return this.firstOnlinePerformanceAdmin;
    },
    determineDeEnvironmentType: function(){
        var de = this.getDeploymentEnvironment();
        if(de == null){
            return null;
        }
        for( var i =0;i<de.attributes.length;i++){
            if(de.attributes[i].name=="environmentType"){
                return de.attributes[i].value;
            }
        }
        
        return null;
    },
    
    determineDeType: function(){
        var de = this.getDeploymentEnvironment();
        if(de == null){
            return null;
        }
        for( var i =0;i<de.attributes.length;i++){
            if(de.attributes[i].name=="type"){
                return de.attributes[i].value;
            }
        }
        
        return null;
    },
    
    getDeploymentEnvironment: function(){
       var method = "getDeploymentEnvironment";
       this.logger.entering(this.clazz,method,"message"); 

        if(com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentEnvironments(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),this.getDmgr().getDmgrProfileName())==null){
            return null;
        }
   
        for(var i=0; i<com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentEnvironments(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),this.getDmgr().getDmgrProfileName()).length; i++){
            if(com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentEnvironments(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),this.getDmgr().getDmgrProfileName())[i].attributes[1].value==this.getDeName()){
                this.logger.logMessage("DE Search successful");
                return com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentEnvironments(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),this.getDmgr().getDmgrProfileName())[i];
            }
        }

       this.logger.exiting(this.clazz,method,"Getting DeploymentEnvironment");
       return null; 
    },
    
    getDeploymentTargets: function(){

       var method = "getDeploymentTargets";
       this.logger.entering(this.clazz,method,"Getting DeploymentTargets"); 


        if(this.getDeName()==null){
            return null;
        }
         if(this.getDeploymentEnvironment()==null){
            return null;
         }
        var deploymentTargets = this.getDeploymentEnvironment().getElementsByTagName("deploymentTargets");
        this.logger.exiting(this.clazz,method,"End of getDeploymentTargets"+deploymentTargets);
        return ( deploymentTargets!=null ? deploymentTargets: null );
    },
    loadConsoles: function(){
       var method = "loadConsoles";
       this.logger.entering(this.clazz,method,"Loading consoles"); 

        var deploymentTargets = this.getDeploymentTargets();
        if(deploymentTargets==null){
                return null;
        }
        // SingleCluster or Standalone
        if(deploymentTargets.length==1){
            if("BPMConfiguration:BPMServer"==com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentTargetType(deploymentTargets[0])){
            
                  if(this.getDeEnvironmentType()=="Process Center"){
                        this.processCenter[0] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessCenterConsole();
                        this.processCenter[0].constructor(deploymentTargets[0].attributes[3].value,deploymentTargets[0].attributes[2].value);                        
                        this.logger.logMessage("Process Center HostName : "+this.processCenter[0].getHostName());
                        this.logger.logMessage("Process Center port : "+this.processCenter[0].getPort());

                    }
                        this.performanceAdmin[0] = new com.ibm.bpm.QuickStart.Consoles.impl.PerformanceAdminConsole();
                        this.performanceAdmin[0].constructor(deploymentTargets[0].attributes[3].value,deploymentTargets[0].attributes[2].value);   

                        this.processAdmin[0] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessAdminConsole();
                        this.processAdmin[0].constructor(deploymentTargets[0].attributes[3].value,deploymentTargets[0].attributes[2].value);

                        this.processPortal[0] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessPortal();
                        this.processPortal[0].constructor(deploymentTargets[0].attributes[3].value,deploymentTargets[0].attributes[2].value);
                        
                        this.logger.logMessage("PerformanceAdmin HostName : "+this.performanceAdmin[0].getHostName());
                        this.logger.logMessage("Performance Admin port: "+this.performanceAdmin[0].getPort());                     
                        this.logger.logMessage("ProcessAdmin host:"+this.processAdmin[0].getHostName());
                        this.logger.logMessage("ProcessAdmin port:"+this.processAdmin[0].getPort());
                        this.logger.logMessage("Processportal Hostname:"+this.processPortal[0].getHostName());
                        this.logger.logMessage("Processportal port:"+this.processPortal[0].getPort());

            } else if ("BPMConfiguration:BPMCluster"==com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getDeploymentTargetType(deploymentTargets[0])){
                var clusterMembersInfo = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getClusterMembersInfo(deploymentTargets[0].attributes[2].value,this.getDmgr().getDmgrProfileName());
                    for(var j=0;j<clusterMembersInfo.length;j++){
                      if(this.getDeEnvironmentType()=="Process Center"){
                        this.processCenter[j] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessCenterConsole();
                        this.processCenter[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value);                        
                        this.logger.logMessage("Process Center HostName : "+this.processCenter[j].getHostName());
                        this.logger.logMessage("Process Center Port : "+this.processCenter[j].getPort());
                        
                       }

                        this.performanceAdmin[j] = new com.ibm.bpm.QuickStart.Consoles.impl.PerformanceAdminConsole();
                        this.performanceAdmin[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value);                        

                        this.processAdmin[j] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessAdminConsole();
                        this.processAdmin[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value); 

                        this.processPortal[j] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessPortal();
                        this.processPortal[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value); 

                        this.logger.logMessage("Performance Admin Hostname"+this.performanceAdmin[j].getHostName());
                        this.logger.logMessage("Performance Admin port"+this.performanceAdmin[j].getPort());
                        this.logger.logMessage("ProcessAdmin host:"+this.processAdmin[j].getHostName());
                        this.logger.logMessage("ProcessAdmin port:"+this.processAdmin[j].getPort());
                        this.logger.logMessage("Processportal host:"+this.processPortal[j].getHostName());
                        this.logger.logMessage("Processportal port:"+this.processPortal[j].getPort());
                    }
            }
        } else { //multiple cluster
            this.logger.logMessage("Number of de targets:"+deploymentTargets.length);
            for(var i=0;i<deploymentTargets.length;i++){
                var clusterMembersInfo = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getClusterMembersInfo(deploymentTargets[i].attributes[2].value,this.getDmgr().getDmgrProfileName());
                var BPMClusterConfigExtension = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getBPMClusterConfigExtension(deploymentTargets[i].attributes[2].value,this.getDmgr().getDmgrProfileName());
                
                if(BPMClusterConfigExtension==null){
                    continue;
                }
                var BPMClusterType = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getBPMClusterType(BPMClusterConfigExtension);
                if(BPMClusterType=="ProcessCenter" || BPMClusterType=="ProcessServer" ){
                    for(var j=0;j<clusterMembersInfo.length;j++){

                      if(this.getDeEnvironmentType()=="Process Center"){
                       
                        this.processCenter[j] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessCenterConsole();
                        this.processCenter[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value);                        

                        this.logger.logMessage("Process Center HostName : "+this.processCenter[j].getHostName());
                        this.logger.logMessage("Process Center Port : "+this.processCenter[j].getPort());
                        this.logger.logMessage("Process Center url : "+this.processCenter[j].getUrl());
                      } 
                        this.processAdmin[j] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessAdminConsole();
                        this.processAdmin[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value); 

                        this.processPortal[j] = new com.ibm.bpm.QuickStart.Consoles.impl.ProcessPortal();
                        this.processPortal[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value); 

                        this.logger.logMessage("ProcessAdmin host:"+this.processAdmin[j].getHostName());
                        this.logger.logMessage("ProcessAdmin port:"+this.processAdmin[j].getPort());
                        this.logger.logMessage("ProcessAdmin url:"+this.processAdmin[j].getUrl());
                        this.logger.logMessage("Processportal Host:"+this.processPortal[j].getHostName());
                        this.logger.logMessage("Processportal port:"+this.processPortal[j].getPort());
                        this.logger.logMessage("Processportal url:"+this.processPortal[j].getUrl());
                    }
                } else if (BPMClusterType=="Support") {
                    for(var j=0;j<clusterMembersInfo.length;j++){
                        this.performanceAdmin[j] = new com.ibm.bpm.QuickStart.Consoles.impl.PerformanceAdminConsole();
                        this.performanceAdmin[j].constructor(clusterMembersInfo[j].attributes[4].value,clusterMembersInfo[j].attributes[1].value);                        
                        this.logger.logMessage("Performance Admin Hostname"+this.performanceAdmin[j].getHostName());
                        this.logger.logMessage("PerformanceAdmin port:"+this.performanceAdmin[j].getPort());
                    }
                }
            }
        }

       this.logger.exiting(this.clazz,method,"End of loading console Links");
    },
    isOnline : function(){
       var method = "isOnline";
       this.logger.entering(this.clazz,method,"start of isOnline"); 

    	var netState = false;
    	var dmgrState = false;
    	var processCenterState = false;
    	var processPortalState = false;
    	var processAdminState = false;
    	var performanceAdminState = false; 
    	if(this.getDmgr().isOnline()){
    		dmgrState = true;
    		if(this.getDeType()!="AdvancedOnly"){
                if(this.getDeEnvironmentType()=="Process Center"){
                    for(var i=0;i<this.getProcessCenter().length;i++){
                         if(this.getProcessCenter()[i].isOnline()){
                             processCenterState = true;
                             break;
                         }
                    }
                }
                
                for(var i=0;i<this.getProcessPortal().length;i++){
                    if(this.getProcessPortal()[i].isOnline()){
                        processPortalState = true;
                        break;
                    }
                 }
                 
                 for(var i=0;i<this.getProcessAdmin().length;i++){
                    if(this.getProcessAdmin()[i].isOnline()){
                        processAdminState = true;
                        break;
                    }
                 }
                 for(var i=0;i<this.getPerformanceAdmin().length;i++){
                    if(this.getPerformanceAdmin()[i].isOnline()){
                        performanceAdminState = true;
                        break;
                    }
                 }
    		}
    	}
    	if(this.getDeType()=="AdvancedOnly"){
    	   netState =  dmgrState;
    	} else if(this.getDeEnvironmentType()=="Process Center"){
    	   netState =  dmgrState && processCenterState && processPortalState && 
    	   processAdminState && performanceAdminState;
    	}else{
    	   netState =  dmgrState && processPortalState && 
           processAdminState && performanceAdminState;
    	}

       this.logger.exiting(this.clazz,method,"End of IsOnline:"+netState);
    	return netState;
    },
    
    startDeploymentEnvironment: function(){
       var method = "startDeploymentEnvironment";
       this.logger.entering(this.clazz,method,"Starting DE"); 
       this.logger.exiting(this.clazz,method,"End of Starting DE");

        return com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.startDE(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),this.getDmgr().getDmgrProfileName(),this.getDeName(),this.getCellUserName(),this.getCellPassword(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getLaunchPadContentDirectory()+"startDE");
    
    },
    stopDeploymentEnvironment: function(){
       var method = "name";
       this.logger.entering(this.clazz,method,"message"); 
       this.logger.exiting(this.clazz,method,"message");

        return com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.stopDE(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),this.getDmgr().getDmgrProfileName(),this.getDeName(),this.getCellUserName(),this.getCellPassword(),com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getLaunchPadContentDirectory()+"stopDE");
    }
    
/*    
    
        var stopDeploymentEnvironmentStep = new com.ibm.bpm.QuickStart.Step.StopDeploymentEnvironment();
        availableFixPacksStep.logName = top.availableFixPacksOutputFile;
        stopDeploymentEnvironmentStep.keyRingLocation = top.keyRingLocation;
        stopDeploymentEnvironmentStep.repositories = top.formatmsg(property('was.repository'),property('wasOfferingId')) + ',' +
        com.ibm.bpm.install.utils.InstallUtils.getProductRepository();
        this.executeStep(stopDeploymentEnvironmentStep);
        this.callbackavailableFixPacks();
},

callbackStartDeploymentEnvironment : function(){

    logger.logMessage("checking availableFixPackStep status");      

    if(this.stopDeploymentEnvironmentStep.isStepComplete){

       //logger.logMessage("AvailableFixPackStep succeed");  
        var applicableFixPacksStep = new com.ibm.bpm.install.serviceability.product.UpdateApplicableFixPacksStep();
        applicableFixPacksStep.availableFixPacksOutputFile = top.availableFixPacksOutputFile+'.sysout';
        this.executeStep(applicableFixPacksStep);
        logger.logMessage("Completed execution of applicableFixPacks");
        this.AvailableWASFixesStepFunction();
        return;

    }else if (top.AvailableFixPacksStepFailed){
        //logger.logMessage("AvailableFixPackStep failed");
        this.AvailableWASFixesStepFunction();
        return;
    }else if(this.runningInterval>this.maxInterval){
        //logger.logMessage("Monitor step max timeout");
        //this.close(new com.ibm.bpm.install.utils.Message("error","timeout"));
        // close dialog
        return;
    }
    setTimeout(dojo.hitch(this, "callbackStartDeploymentEnvironment"), this.stepInterval);
} 
executeStep: function(step){
    //Run step
    logger.logMessage("Start of execute step");
    var response = step.execute();

    // Monitor step for completion.
    if(response) {
        logger.logMessage("do monitor step");
        this.runningInterval = 0;
        this.monitorStep(step); 
    }
    //if false command execution failed. Don't do monitor step
    logger.logMessage("end of execute step");
},

monitorStep: function(step){
    //Check to see if the step is done.
    logger.logMessage("Start of monitor step");
    if (step.isDone()) { 
        logger.logMessage("isDone returned true");
        return;
    }
    else {
        //Infinite loop checker
        this.runningInterval =  this.runningInterval + this.stepInterval;
        logger.logMessage("Current running interval "+this.runningInterval);

        if(this.runningInterval>this.maxInterval){
            logger.logMessage("Monitor step max timeout");
            return;
        }
        logger.logMessage("Before monitor timeout call");
        setTimeout(dojo.hitch(this, "monitorStep" , step), this.stepInterval);
    }
},


*/
    
});
